"""


No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

The version of the OpenAPI document: 1.0.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from __future__ import annotations

import json
import pprint
from typing import Any, Dict, Optional, Set, Union

from pydantic import BaseModel, ConfigDict, ValidationError, field_validator
from typing_extensions import Self

from annofabapi.pydantic_models.annotation_thumbnail_detail_failed import AnnotationThumbnailDetailFailed
from annofabapi.pydantic_models.annotation_thumbnail_detail_image_slice import AnnotationThumbnailDetailImageSlice
from annofabapi.pydantic_models.annotation_thumbnail_detail_unsupported import AnnotationThumbnailDetailUnsupported

ANNOTATIONTHUMBNAILDETAIL_ONE_OF_SCHEMAS = [
    "AnnotationThumbnailDetailFailed",
    "AnnotationThumbnailDetailImageSlice",
    "AnnotationThumbnailDetailUnsupported",
]


class AnnotationThumbnailDetail(BaseModel):
    """
    - **AnnotationThumbnailDetailImageSlice**:<br>   画像の一部をサムネイルとして使用する - **AnnotationThumbnailDetailUnsupported**:<br>   サムネイル生成に対応していない - **AnnotationThumbnailDetailFailed**:<br>   サムネイル生成に失敗した
    """

    # data type: AnnotationThumbnailDetailImageSlice
    oneof_schema_1_validator: Optional[AnnotationThumbnailDetailImageSlice] = None
    # data type: AnnotationThumbnailDetailUnsupported
    oneof_schema_2_validator: Optional[AnnotationThumbnailDetailUnsupported] = None
    # data type: AnnotationThumbnailDetailFailed
    oneof_schema_3_validator: Optional[AnnotationThumbnailDetailFailed] = None
    actual_instance: Optional[Union[AnnotationThumbnailDetailFailed, AnnotationThumbnailDetailImageSlice, AnnotationThumbnailDetailUnsupported]] = (
        None
    )
    one_of_schemas: Set[str] = {"AnnotationThumbnailDetailFailed", "AnnotationThumbnailDetailImageSlice", "AnnotationThumbnailDetailUnsupported"}

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )

    discriminator_value_class_map: Dict[str, str] = {}

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator("actual_instance")
    def actual_instance_must_validate_oneof(cls, v):
        instance = AnnotationThumbnailDetail.model_construct()
        error_messages = []
        match = 0
        # validate data type: AnnotationThumbnailDetailImageSlice
        if not isinstance(v, AnnotationThumbnailDetailImageSlice):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AnnotationThumbnailDetailImageSlice`")
        else:
            match += 1
        # validate data type: AnnotationThumbnailDetailUnsupported
        if not isinstance(v, AnnotationThumbnailDetailUnsupported):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AnnotationThumbnailDetailUnsupported`")
        else:
            match += 1
        # validate data type: AnnotationThumbnailDetailFailed
        if not isinstance(v, AnnotationThumbnailDetailFailed):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AnnotationThumbnailDetailFailed`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when setting `actual_instance` in AnnotationThumbnailDetail with oneOf schemas: AnnotationThumbnailDetailFailed, AnnotationThumbnailDetailImageSlice, AnnotationThumbnailDetailUnsupported. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when setting `actual_instance` in AnnotationThumbnailDetail with oneOf schemas: AnnotationThumbnailDetailFailed, AnnotationThumbnailDetailImageSlice, AnnotationThumbnailDetailUnsupported. Details: "
                + ", ".join(error_messages)
            )
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AnnotationThumbnailDetailImageSlice
        try:
            instance.actual_instance = AnnotationThumbnailDetailImageSlice.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AnnotationThumbnailDetailUnsupported
        try:
            instance.actual_instance = AnnotationThumbnailDetailUnsupported.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into AnnotationThumbnailDetailFailed
        try:
            instance.actual_instance = AnnotationThumbnailDetailFailed.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError(
                "Multiple matches found when deserializing the JSON string into AnnotationThumbnailDetail with oneOf schemas: AnnotationThumbnailDetailFailed, AnnotationThumbnailDetailImageSlice, AnnotationThumbnailDetailUnsupported. Details: "
                + ", ".join(error_messages)
            )
        elif match == 0:
            # no match
            raise ValueError(
                "No match found when deserializing the JSON string into AnnotationThumbnailDetail with oneOf schemas: AnnotationThumbnailDetailFailed, AnnotationThumbnailDetailImageSlice, AnnotationThumbnailDetailUnsupported. Details: "
                + ", ".join(error_messages)
            )
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(
        self,
    ) -> Optional[Union[Dict[str, Any], AnnotationThumbnailDetailFailed, AnnotationThumbnailDetailImageSlice, AnnotationThumbnailDetailUnsupported]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())
